searchNodes=[{"type":"module","title":"Membrane.TelemetryMetrics","doc":"Defines macros for executing telemetry events and registering processes with events. Provided macros evalueates to meaningful code or to nothing, depending on config values, in order to achieve performance boost, when specific event or whole telemetry is not in use.","ref":"Membrane.TelemetryMetrics.html"},{"type":"macro","title":"Membrane.TelemetryMetrics.conditional_execute/5","doc":"Evaluates to conditional call to :telemetry.execute/3 or to nothing, depending on if specific event is enabled in config file. If event is enabled, :telemetry.execute/3 will be executed only if value returned by call to func will be truthly.","ref":"Membrane.TelemetryMetrics.html#conditional_execute/5"},{"type":"macro","title":"Membrane.TelemetryMetrics.execute/4","doc":"Evaluates to call to :telemetry.execute/3 or to nothing, depending on if specific event is enabled in config file.","ref":"Membrane.TelemetryMetrics.html#execute/4"},{"type":"macro","title":"Membrane.TelemetryMetrics.register/2","doc":"Evalueates to call to Membrane.TelemetryMetrics.Monitor.start/3 or to nothing, depending on if specific event is enabled in config file. Should be called in every process, that will execute event linked with metric aggregated by some instance of Membrane.TelemetryMetrics.Reporter .","ref":"Membrane.TelemetryMetrics.html#register/2"},{"type":"type","title":"Membrane.TelemetryMetrics.label/0","doc":"","ref":"Membrane.TelemetryMetrics.html#t:label/0"},{"type":"module","title":"Membrane.TelemetryMetrics.Reporter","doc":"Attaches handlers to :telemetry events based on the received list of metrics definitions. The attached handlers store metrics values in ETS tables. These values can be gotten by calling scrape/2 function or also reset by calling scrape_and_cleanup/2 . Currently supported types of metrics are: Telemetry.Metrics.Counter Telemetry.Metrics.Sum Telemetry.Metrics.LastValue Currently supported fields of metrics definitions are: :name , :event_name , measurement . Fields :keep , :reporter_options , tag_values , tags , :unit and functionalities related to them are not supported yet. Metrics values are grouped by label .","ref":"Membrane.TelemetryMetrics.Reporter.html"},{"type":"function","title":"Membrane.TelemetryMetrics.Reporter.child_spec/1","doc":"Returns a specification to start this module under a supervisor. See Supervisor .","ref":"Membrane.TelemetryMetrics.Reporter.html#child_spec/1"},{"type":"function","title":"Membrane.TelemetryMetrics.Reporter.scrape/2","doc":"","ref":"Membrane.TelemetryMetrics.Reporter.html#scrape/2"},{"type":"function","title":"Membrane.TelemetryMetrics.Reporter.scrape_and_cleanup/2","doc":"","ref":"Membrane.TelemetryMetrics.Reporter.html#scrape_and_cleanup/2"},{"type":"function","title":"Membrane.TelemetryMetrics.Reporter.start_link/2","doc":"","ref":"Membrane.TelemetryMetrics.Reporter.html#start_link/2"},{"type":"function","title":"Membrane.TelemetryMetrics.Reporter.stop/1","doc":"","ref":"Membrane.TelemetryMetrics.Reporter.html#stop/1"},{"type":"type","title":"Membrane.TelemetryMetrics.Reporter.report/0","doc":"","ref":"Membrane.TelemetryMetrics.Reporter.html#t:report/0"},{"type":"type","title":"Membrane.TelemetryMetrics.Reporter.reporter/0","doc":"","ref":"Membrane.TelemetryMetrics.Reporter.html#t:reporter/0"},{"type":"extras","title":"Membrane Telmetry Metrics","doc":"This repository contains a tool for generating metrics. It is part of Membrane Multimedia Framework .","ref":"readme.html"},{"type":"extras","title":"Membrane Telmetry Metrics - Installation","doc":"The package can be installed by adding membrane_telemetry_metrics to your list of dependencies in mix.exs : def deps do [ { :membrane_telemetry_metrics , &quot;~&gt; 0.1.0&quot; } ] end","ref":"readme.html#installation"},{"type":"extras","title":"Membrane Telmetry Metrics - Usage","doc":"The usage example below illustrates, how you can use this tool to aggregate metrics and generate reports containing their values. In this case, we have a scenario, where a couple of people are doing their shopping, and we want to have access to the reports with some metrics about them, without calling each of these people directly. To benefit from of full functionality offered by this tool, you have to use both Membrane.TelemetryMetrics and Mebrane.TelemetryMetrics.Reporter . First, put config :membrane_telemetry_metrics , enabled : true in your config.exs . You can also pass list of events, that will be enabled in :events option (in this case, it would be [[:shopping]] ). If you don't specify that option, all events will be enabled. Let's assume, that you want to track three metrics: cash_spent number_of_payments last_visited_shop So, the definition of our list of metrics will look like metrics = [ Telemetry.Metrics . sum ( &quot;cash_spent&quot; , event_name : [ :shopping ] , measurement : :payment ) , Telemetry.Metrics . counter ( &quot;number_of_payments&quot; , event_name : [ :shopping ] ) , Telemetry.Metrics . last_value ( &quot;last_visited_shop&quot; , event_name : [ :shopping ] , measurement : :shop ) ] Then, you have to start Mebrane.TelemetryMetrics.Reporter . It can be made by calling Membrane.TelemetryMetrics.Reporter . start_link ( metrics , name : ShoppingReporter ) but the suggested way is to do it under Supervisor tree, in Application module. Now, ShoppingReporter is ready to aggregate metrics from emitted events. But before that, we have to register our event in every process, that will emit it. Let's assume, that we want to aggregate data about three people: James Smith , Mary Smith and Patricia Johnson . Events with data about each of these people will be emitted in a different process. In John Smith 's process we will execute code require Membrane.TelemetryMetrics Membrane.TelemetryMetrics . register ( [ :shopping ] , [ name : &quot;James&quot; , surname : &quot;Smith&quot; ] ) Membrane.TelemetryMetrics . execute ( [ :shopping ] , %{ shop : &quot;Grocery&quot; , payment : 10 } , %{ } , [ name : &quot;James&quot; , surname : &quot;Smith&quot; ] ) Membrane.TelemetryMetrics . execute ( [ :shopping ] , %{ shop : &quot;Bakery&quot; , payment : 5 } , %{ } , [ name : &quot;James&quot; , surname : &quot;Smith&quot; ] ) Membrane.TelemetryMetrics . execute ( [ :shopping ] , %{ shop : &quot;Jeweller&quot; , payment : 100 } , %{ } , [ name : &quot;James&quot; , surname : &quot;Smith&quot; ] ) In Mary Smith 's process we will execute code require Membrane.TelemetryMetrics Membrane.TelemetryMetrics . register ( [ :shopping ] , [ name : &quot;Mary&quot; , surname : &quot;Smith&quot; ] ) Membrane.TelemetryMetrics . execute ( [ :shopping ] , %{ shop : &quot;Bookshop&quot; , payment : 25 } , %{ } , [ name : &quot;Mary&quot; , surname : &quot;Smith&quot; ] ) Membrane.TelemetryMetrics . execute ( [ :shopping ] , %{ shop : &quot;Butcher&quot; , payment : 15 } , %{ } , [ name : &quot;Mary&quot; , surname : &quot;Smith&quot; ] ) In Patricia Johnson 's process we will execute code require Membrane.TelemetryMetrics Membrane.TelemetryMetrics . register ( [ :shopping ] , [ name : &quot;Patricia&quot; , surname : &quot;Johnson&quot; ] ) Membrane.TelemetryMetrics . execute ( [ :shopping ] , %{ shop : &quot;Newsagent&quot; , payment : 5 } , %{ } , [ name : &quot;Patricia&quot; , surname : &quot;Johnson&quot; ] ) Then, calling Membrane.TelemetryMetrics.Reporter . scrape ( ShoppingReporter ) from anywhere on this same node, as noticed processes, will cause getting the following result: %{ { :surname , &quot;Johnson&quot; } =&gt; %{ { :name , &quot;Patricia&quot; } =&gt; %{ &quot;cash_spent&quot; =&gt; 5 , &quot;last_visited_shop&quot; =&gt; &quot;Newsagent&quot; , &quot;number_of_payments&quot; =&gt; 1 } } , { :surname , &quot;Smith&quot; } =&gt; %{ { :name , &quot;James&quot; } =&gt; %{ &quot;cash_spent&quot; =&gt; 115 , &quot;last_visited_shop&quot; =&gt; &quot;Jeweller&quot; , &quot;number_of_payments&quot; =&gt; 3 } , { :name , &quot;Mary&quot; } =&gt; %{ &quot;cash_spent&quot; =&gt; 40 , &quot;last_visited_shop&quot; =&gt; &quot;Butcher&quot; , &quot;number_of_payments&quot; =&gt; 2 } } } Then, for example, if Mary Smith 's process exits, you will get a report like %{ { :surname , &quot;Johnson&quot; } =&gt; %{ { :name , &quot;Patricia&quot; } =&gt; %{ &quot;cash_spent&quot; =&gt; 5 , &quot;last_visited_shop&quot; =&gt; &quot;Newsagent&quot; , &quot;number_of_payments&quot; =&gt; 1 } } , { :surname , &quot;Smith&quot; } =&gt; %{ { :name , &quot;James&quot; } =&gt; %{ &quot;cash_spent&quot; =&gt; 115 , &quot;last_visited_shop&quot; =&gt; &quot;Jeweller&quot; , &quot;number_of_payments&quot; =&gt; 3 } } } If a process registers an event by calling Membrane.TelemetryMetrics . register ( event_name , label ) and exits after it, every metric that aggregated measurements from an event with event_name will drop its values held for a specific value of label , as in the example above Mary Smith has disappeared from the report, after the end of her's process.","ref":"readme.html#usage"},{"type":"extras","title":"Membrane Telmetry Metrics - Copyright and License","doc":"Copyright 2022, Software Mansion Licensed under the Apache License, Version 2.0","ref":"readme.html#copyright-and-license"},{"type":"extras","title":"LICENSE","doc":"Apache License Version 2.0, January 2004 http://www.apache.org/licenses/ TERMS AND CONDITIONS FOR USE, REPRODUCTION, AND DISTRIBUTION 1. Definitions. &quot;License&quot; shall mean the terms and conditions for use, reproduction, and distribution as defined by Sections 1 through 9 of this document. &quot;Licensor&quot; shall mean the copyright owner or entity authorized by the copyright owner that is granting the License. &quot;Legal Entity&quot; shall mean the union of the acting entity and all other entities that control, are controlled by, or are under common control with that entity. For the purposes of this definition, &quot;control&quot; means (i) the power, direct or indirect, to cause the direction or management of such entity, whether by contract or otherwise, or (ii) ownership of fifty percent (50%) or more of the outstanding shares, or (iii) beneficial ownership of such entity. &quot;You&quot; (or &quot;Your&quot;) shall mean an individual or Legal Entity exercising permissions granted by this License. &quot;Source&quot; form shall mean the preferred form for making modifications, including but not limited to software source code, documentation source, and configuration files. &quot;Object&quot; form shall mean any form resulting from mechanical transformation or translation of a Source form, including but not limited to compiled object code, generated documentation, and conversions to other media types. &quot;Work&quot; shall mean the work of authorship, whether in Source or Object form, made available under the License, as indicated by a copyright notice that is included in or attached to the work (an example is provided in the Appendix below). &quot;Derivative Works&quot; shall mean any work, whether in Source or Object form, that is based on (or derived from) the Work and for which the editorial revisions, annotations, elaborations, or other modifications represent, as a whole, an original work of authorship. For the purposes of this License, Derivative Works shall not include works that remain separable from, or merely link (or bind by name) to the interfaces of, the Work and Derivative Works thereof. &quot;Contribution&quot; shall mean any work of authorship, including the original version of the Work and any modifications or additions to that Work or Derivative Works thereof, that is intentionally submitted to Licensor for inclusion in the Work by the copyright owner or by an individual or Legal Entity authorized to submit on behalf of the copyright owner. For the purposes of this definition, &quot;submitted&quot; means any form of electronic, verbal, or written communication sent to the Licensor or its representatives, including but not limited to communication on electronic mailing lists, source code control systems, and issue tracking systems that are managed by, or on behalf of, the Licensor for the purpose of discussing and improving the Work, but excluding communication that is conspicuously marked or otherwise designated in writing by the copyright owner as &quot;Not a Contribution.&quot; &quot;Contributor&quot; shall mean Licensor and any individual or Legal Entity on behalf of whom a Contribution has been received by Licensor and subsequently incorporated within the Work. 2. Grant of Copyright License. Subject to the terms and conditions of this License, each Contributor hereby grants to You a perpetual, worldwide, non-exclusive, no-charge, royalty-free, irrevocable copyright license to reproduce, prepare Derivative Works of, publicly display, publicly perform, sublicense, and distribute the Work and such Derivative Works in Source or Object form. 3. Grant of Patent License. Subject to the terms and conditions of this License, each Contributor hereby grants to You a perpetual, worldwide, non-exclusive, no-charge, royalty-free, irrevocable (except as stated in this section) patent license to make, have made, use, offer to sell, sell, import, and otherwise transfer the Work, where such license applies only to those patent claims licensable by such Contributor that are necessarily infringed by their Contribution(s) alone or by combination of their Contribution(s) with the Work to which such Contribution(s) was submitted. If You institute patent litigation against any entity (including a cross-claim or counterclaim in a lawsuit) alleging that the Work or a Contribution incorporated within the Work constitutes direct or contributory patent infringement, then any patent licenses granted to You under this License for that Work shall terminate as of the date such litigation is filed. 4. Redistribution. You may reproduce and distribute copies of the Work or Derivative Works thereof in any medium, with or without modifications, and in Source or Object form, provided that You meet the following conditions: (a) You must give any other recipients of the Work or Derivative Works a copy of this License; and (b) You must cause any modified files to carry prominent notices stating that You changed the files; and (c) You must retain, in the Source form of any Derivative Works that You distribute, all copyright, patent, trademark, and attribution notices from the Source form of the Work, excluding those notices that do not pertain to any part of the Derivative Works; and (d) If the Work includes a &quot;NOTICE&quot; text file as part of its distribution, then any Derivative Works that You distribute must include a readable copy of the attribution notices contained within such NOTICE file, excluding those notices that do not pertain to any part of the Derivative Works, in at least one of the following places: within a NOTICE text file distributed as part of the Derivative Works; within the Source form or documentation, if provided along with the Derivative Works; or, within a display generated by the Derivative Works, if and wherever such third-party notices normally appear. The contents of the NOTICE file are for informational purposes only and do not modify the License. You may add Your own attribution notices within Derivative Works that You distribute, alongside or as an addendum to the NOTICE text from the Work, provided that such additional attribution notices cannot be construed as modifying the License. You may add Your own copyright statement to Your modifications and may provide additional or different license terms and conditions for use, reproduction, or distribution of Your modifications, or for any such Derivative Works as a whole, provided Your use, reproduction, and distribution of the Work otherwise complies with the conditions stated in this License. 5. Submission of Contributions. Unless You explicitly state otherwise, any Contribution intentionally submitted for inclusion in the Work by You to the Licensor shall be under the terms and conditions of this License, without any additional terms or conditions. Notwithstanding the above, nothing herein shall supersede or modify the terms of any separate license agreement you may have executed with Licensor regarding such Contributions. 6. Trademarks. This License does not grant permission to use the trade names, trademarks, service marks, or product names of the Licensor, except as required for reasonable and customary use in describing the origin of the Work and reproducing the content of the NOTICE file. 7. Disclaimer of Warranty. Unless required by applicable law or agreed to in writing, Licensor provides the Work (and each Contributor provides its Contributions) on an &quot;AS IS&quot; BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied, including, without limitation, any warranties or conditions of TITLE, NON-INFRINGEMENT, MERCHANTABILITY, or FITNESS FOR A PARTICULAR PURPOSE. You are solely responsible for determining the appropriateness of using or redistributing the Work and assume any risks associated with Your exercise of permissions under this License. 8. Limitation of Liability. In no event and under no legal theory, whether in tort (including negligence), contract, or otherwise, unless required by applicable law (such as deliberate and grossly negligent acts) or agreed to in writing, shall any Contributor be liable to You for damages, including any direct, indirect, special, incidental, or consequential damages of any character arising as a result of this License or out of the use or inability to use the Work (including but not limited to damages for loss of goodwill, work stoppage, computer failure or malfunction, or any and all other commercial damages or losses), even if such Contributor has been advised of the possibility of such damages. 9. Accepting Warranty or Additional Liability. While redistributing the Work or Derivative Works thereof, You may choose to offer, and charge a fee for, acceptance of support, warranty, indemnity, or other liability obligations and/or rights consistent with this License. However, in accepting such obligations, You may act only on Your own behalf and on Your sole responsibility, not on behalf of any other Contributor, and only if You agree to indemnify, defend, and hold each Contributor harmless for any liability incurred by, or claims asserted against, such Contributor by reason of your accepting any such warranty or additional liability. END OF TERMS AND CONDITIONS APPENDIX: How to apply the Apache License to your work. To apply the Apache License to your work, attach the following boilerplate notice, with the fields enclosed by brackets &quot;[]&quot; replaced with your own identifying information. (Don't include the brackets!) The text should be enclosed in the appropriate comment syntax for the file format. We also recommend that a file or class name and description of purpose be included on the same &quot;printed page&quot; as the copyright notice for easier identification within third-party archives. Copyright 2020 Software Mansion Licensed under the Apache License, Version 2.0 (the &quot;License&quot;); you may not use this file except in compliance with the License. You may obtain a copy of the License at http://www.apache.org/licenses/LICENSE-2.0 Unless required by applicable law or agreed to in writing, software distributed under the License is distributed on an &quot;AS IS&quot; BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the License for the specific language governing permissions and limitations under the License.","ref":"license.html"}]